from emod_api import schema_to_class as s2c
import emod_api.interventions.common as common
import emod_api.interventions.utils as utils
from emodpy_tbhiv.interventions import purge_campaign_event

def DiagnosticTreatNeg(
        camp,
        trigger_treatment_list,
        base_sensitivity_smearpos=1.0,
        base_sensitivity_smearneg=1.0,
        pos_event= 'TBTestPositive',
        neg_event= 'TBTestNegative',
        def_event= 'TBTestDefault',
        treatment_fraction= 1,
        start_day=0,
        duration=-1,
        property_restrictions_list=[],
        nodeIDs=[],
        black_period=0,
        black_trigger='Blackout',
        event_name='TB Diagnosis'):
    """
    DiagnosticTreatNeg
    :param TBD
    Note start_day is initialized as 1, recommend that this be aligned with the start of the simulation
    """
    schema_path = camp.schema_path
    intervention = s2c.get_class_with_defaults( "DiagnosticTreatNeg", schema_path )
    intervention.Base_Sensitivity = base_sensitivity_smearpos
    intervention.Base_Specificity = base_sensitivity_smearneg
    intervention.Treatment_Fraction = treatment_fraction
    intervention.Event_Or_Config = 'Event'
    intervention.Positive_Diagnosis_Event = camp.get_send_trigger( pos_event )
    intervention.Negative_Diagnosis_Event = camp.get_send_trigger( neg_event )
    intervention.Defaulters_Event = camp.get_send_trigger( def_event )

    event = common.TriggeredCampaignEvent( camp, start_day,event_name, trigger_treatment_list, [ intervention ], Nodeset_Config=utils.do_nodes( camp.schema_path, nodeIDs ), Duration=duration, Property_Restrictions=property_restrictions_list )
    purge_campaign_event( event )

    return event

def new_intervention_as_file( camp, filename="dtn.json" ):
    camp.add( DiagnosticTreatNeg( camp, trigger_treatment_list=[ "Births" ] ) )
    camp.save( filename )
    return filename

