#!/usr/bin/env python
import unittest
import copy
import json
import os
import manifest
from intervention_test import TestIntervention

import emodpy_tbhiv.interventions.tb_treat_pddrug as tbtd
import emod_api.campaign as camp

# Doesn't currently work due to list of drug names
class Testtbtreatpddrug(TestIntervention):
    """
    Test AntiTBPropDepDrug intervention
    # https://github.com/InstituteforDiseaseModeling/emodpy-tbhiv/issues/15
    """
    def skip_test_default(self):
        super().trigger_treatment_list_with_drug_name_test(tbtd.TBPropDepDrugTreatment, ["DOTS"],
                                                           "AntiTBPropDepDrug", 'camp_tbtreatpddrug.json')

    def skip_test_all(self):
        camp.schema_path = self.schema

        trigger_treatment_list = ['infected']
        # This creates an error because intervention.DrugTypeByProperty  not in object: drug_names = ['DOTS']
        drug_names = 'DOTS'
        state_enabled=1
        start_day=5
        treatment_duration=180
        duration=100
        property_restrictions_list=["Risk: HIGH"]
        nodeIDs=[]
        black_period=20
        black_trigger='Blackout'
        event_name='TB Treatment PD Drug'

        event = tbtd.TBPropDepDrugTreatment(camp, trigger_treatment_list, drug_names, state_enabled,
                                         start_day, treatment_duration, 
                                         duration, property_restrictions_list, nodeIDs, black_period,
                                         black_trigger, event_name)

        camp.campaign_dict["Events"] = []
        camp.add(event)
        camp_filename = os.path.join(self.output, "camp_tb_treatpd.json")
        manifest.delete_existing_file(camp_filename)
        camp.save(camp_filename)
        self.assertTrue(os.path.isfile(camp_filename))
        
        with open(camp_filename, 'r') as file:
            camp_file = json.load(file)

        ecc = camp_file["Events"][0]["Event_Coordinator_Config"]
        ic = ecc["Intervention_Config"]

        # Need to look at output before adding assertions, currently does not run


if __name__ == '__main__':
    unittest.main()

